#ifndef CONTEXT_BREAK_H_INCLUDED
#define CONTEXT_BREAK_H_INCLUDED 1

#include <e32std.h>


#ifdef __WINS__
IMPORT_C void BreakOnAllLeaves(void*);
IMPORT_C void BreakInClassModule();
IMPORT_C void BreakInActiveObject();


class TBreakItem {
public:
	IMPORT_C TBreakItem(class MApp_context*, TInt &aError, TInt aDontBreakOn=KErrNone);
	IMPORT_C ~TBreakItem();
private:
	TPtrC8 iInClass;
	TInt &iError;
	TInt iDontBreakOn;
	TBreakItem* iPreviousItem; MApp_context* ctx;
	friend void BreakOnAllLeaves2(void* aArg);
};

#  ifndef __LEAVE_EQUALS_THROW__
#define CC_TRAP(_r, _s) { TTrap __t;if (__t.Trap(_r)==0){ { TBreakItem __breakitem(GetContext(), _r); _s; } TTrap::UnTrap();}}
#define CC_TRAPIGNORE(_r, _ignore, _s) { TTrap __t;if (__t.Trap(_r)==0){ { TBreakItem __breakitem(GetContext(), _r, _ignore); _s; } TTrap::UnTrap();}}
#define CC_TRAPD(_r, _s) TInt _r;{TTrap __t;if (__t.Trap(_r)==0){  { TBreakItem __breakitem(GetContext(), _r); _s; } TTrap::UnTrap();}}
#define CC_TRAP2(_r, _s, _c) {TTrap __t;if (__t.Trap(_r)==0){ { TBreakItem __breakitem(_c, _r); _s; } TTrap::UnTrap();}}
#  else
#define CC_TRAP(_r, _s) TRAP(_r, { TBreakItem __breakitem(GetContext(), _r); _s; } )
#define CC_TRAPIGNORE(_r, _ignore, _s) TRAP(_r, { TBreakItem __breakitem(GetContext(), _r, _ignore); _s; } )
#define CC_TRAPD(_r, _s) TRAPD(_r, { TBreakItem __breakitem(GetContext(), _r); _s; })
#define CC_TRAP2(_r, _s, _c) TRAP(_r, { TBreakItem __breakitem(_c, _r); _s; } )
#  endif

#else

#define CC_TRAP(_r, _s) TRAP(_r, _s)
#define CC_TRAPIGNORE(_r, _ignore, _s) TRAP(_r, _s)
#define CC_TRAPD(_r, _s) TRAPD(_r, _s)
#define CC_TRAP2(_r, _s, _c) TRAP(_r, _s)
#endif

#endif
