#include "break.h"

#ifdef __WINS__
#include <e32base.h>
#include "app_context.h"
#include "app_context_impl.h"
#include "callstack.h"

void BreakOnAllLeaves2(void* aArg)
{
	TBreakItem* i=(TBreakItem*) aArg;
	TInt error=i->iError;
	if (i->ctx) i->ctx->iCurrentBreakItem=i->iPreviousItem;
	void *cname=&(i->iInClass);
	if (error==KErrNoMemory) return;
	do {
		if (error==i->iDontBreakOn) return;
		i=i->iPreviousItem;
	} while(i);
	BreakOnAllLeaves(cname);
}

EXPORT_C void BreakOnAllLeaves(void* aArg)
{
	TPtrC8* classname=(TPtrC8*)aArg;
	MApp_context* c;
	if (classname->Length()>0) {
		c=GetContext();
		if (c && classname->Compare(c->CallStackMgr().GetCurrentClass())!=0) {
			BreakInClassModule();
		}
	} else {
		BreakInClassModule();
	}
}
EXPORT_C void BreakInClassModule()
{
}

EXPORT_C void BreakInActiveObject()
{
}

EXPORT_C TBreakItem::TBreakItem(MApp_context* c, TInt& aError, TInt aDontBreakOn) : iInClass(0, 0), iError(aError), iDontBreakOn(aDontBreakOn)
{ 
	ctx=c;
	if (c) { 
		iInClass.Set(c->CallStackMgr().GetCurrentClass()); 
		iPreviousItem=c->iCurrentBreakItem;
		c->iCurrentBreakItem=this;
	} else {
		iPreviousItem=0;
	}
	CleanupStack::PushL(TCleanupItem(BreakOnAllLeaves2, this));
}

EXPORT_C TBreakItem::~TBreakItem()
{
	if (ctx) { ctx->iCurrentBreakItem=iPreviousItem; }
	CleanupStack::Pop();
}
#endif