#ifndef CONTEXT_CONTEXTDOC_H_INCLUDED
#define CONTEXT_CONTEXTDOC_H_INCLUDED 1

#include <e32std.h>

class MInitializationObserver {
public:
	virtual void StepDone() = 0;
};

class MContextDocument {
protected:
	IMPORT_C void ConstructL(class CApaApplication* aApp, 
		const class MDefaultSettings& DefaultSettings,
		const struct TTupleName& aSettingTupleName,
		const TDesC& aDebugLog,
		const TDesC& aChunkName);
	IMPORT_C virtual ~MContextDocument();
	IMPORT_C static TInt InitializationSteps();

	class CApp_context* iContext;
	class CBBSession*	iBBSession;
	class CBBDataFactory* iBBDataFactory;
	class CActiveScheduler	*iBuiltinScheduler;
	class CDebugAppScheduler *iDebugScheduler;
protected:
	IMPORT_C virtual void StepDone();
private:
	void InnerConstructL(class CApaApplication* aApp, 
		const class MDefaultSettings& DefaultSettings,
		const struct TTupleName& aSettingTupleName);
};

#endif
