#ifndef CONTEXTCONTACTSDETAILVIEW_H
#define CONTEXTCONTACTSDETAILVIEW_H

#include <aknview.h>
#include <cpbkviewstate.h>
#include <sendui.h>
#include "app_context.h"
#include "phonehelper_ui.h"
#include "phonebook.h"
#include <akniconarray.h>

const TUid KDetailViewId = {4};

class CContextContactsDetailContainer;

class CContextContactsDetailView : public CAknView, public MContextBase
    {
    public: 
	CContextContactsDetailView(phonehelper_ui &aHelper, CAknIconArray * iconlist) : aPhoneHelper(aHelper), aIconlist(iconlist), owns_engine(false), mailbox_defined(EFalse) { }
        void ConstructL();
	~CContextContactsDetailView();

    public: 
        TUid Id() const;
	void DynInitMenuPaneL(TInt aResourceId, CEikMenuPane* aMenuPane);
        void HandleCommandL(TInt aCommand);
        void HandleClientRectChange();
	void Refresh();

    private:

        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId,
            const TDesC8& aCustomMessage);
        void DoDeactivate();

    private: 
        CContextContactsDetailContainer* iContainer;
	TVwsViewId iPrevViewId;
	CPbkViewState * iViewState;
	CSendAppUi* iSendAppUi;
	phonehelper_ui& aPhoneHelper;
	bool owns_engine;
	CPbkContactEngine * pbkengine;
	CPbkContactItem * iItem;
	CAknIconArray * aIconlist;
	TBool mailbox_defined;
    };

#endif

// End of File
