#include "ContextContactsDocument.h"
#include "ContextContactsAppUi.h"
#include "settings.h"

#include "bb_settings.h"
#include "cl_settings.h"
#include "cbbsession.h"

CContextContactsDocument::CContextContactsDocument(CEikApplication& aApp)
: CAknDocument(aApp) { }

CContextContactsDocument::~CContextContactsDocument()
{
}

void CContextContactsDocument::ConstructL()
{
	MContextDocument::ConstructL(Application(),
		iDefaultSettings, KCLSettingsTuple,
		_L("contextcontacts.txt"), _L("contacts"));

#ifdef __WINS__
	iContext->SetAppDir(_L("c:\\system\\apps\\contextcontacts\\"));
#endif
}

CContextContactsDocument* CContextContactsDocument::NewL(
							 CEikApplication& aApp)     // CContextContactsApp reference
{	
	CContextContactsDocument* self = new (ELeave) CContextContactsDocument( aApp );
	CleanupStack::PushL( self );
	self->ConstructL();
	CleanupStack::Pop();
	
	return self;
}


CEikAppUi* CContextContactsDocument::CreateAppUiL()
{
	CALLSTACKITEM_N(_CL("CContextContactsDocument"), _CL("CreateAppUiL"));
	
	return new (ELeave) CContextContactsAppUi(*iContext);
}

