#ifndef __JAIKUCONTACTSLISTBOX_H__
#define __JAIKUCONTACTSLISTBOX_H__

// From Context
#include <app_context.h>

// From S60
#include <aknutils.h>
#include <e32base.h>
#include <eikfrlb.h>



class CCoeControl;
class MDesCArray;
class CGulIcon;
class phonebook_i;

class CJaikuContactsLBModel : public CAknFilteredTextListBoxModel,
			      public MContextBase
    {
public: 
    IMPORT_C void SetFilterArray( MDesCArray* aFilterArray );
    IMPORT_C static CJaikuContactsLBModel* NewL();    

public:
    virtual const MDesCArray* MatchableTextArray() const;
private:
    MDesCArray* iFilterArray;
    };


class CJaikuContactsListBox : public CEikFormattedCellListBox,
			      public MContextBase
    {
public: // public API 
    IMPORT_C static CJaikuContactsListBox* CreateListboxL( 
	CCoeControl* aParent,
	phonebook_i& aPhonebook);
    
    IMPORT_C static MDesCArray* CreateLBArrayL( phonebook_i& aPhonebook );


public:
    
    /**
     * Adjust rect and calls SetRect
     * @returns adjusted rect for later reference
     */
    IMPORT_C TRect AdjustAndSetRect( TRect aRect );

    IMPORT_C CJaikuContactsLBModel* JaikuModel() const;

protected: // from base classes
    void SizeChanged();
    void CreateItemDrawerL();
    CJaikuContactsListBox( phonebook_i& aPhonebook );
private:
    void SetupSubcellsL();

private:
    phonebook_i& iPhonebook;
    };
#endif // __JAIKUCONTACTSLISTBOX_H__
