#ifndef CONTEXT_CM_AUTOTAGLIST_H_INCLUDED
#define CONTEXT_CM_AUTOTAGLIST_H_INCLUDED 1

#include <e32base.h>
#include <bamdesca.h>
#include <eikfrlbd.h> 

class MAskForNames {
public:
	virtual TBool NameCell(TInt aBaseId, const class TBBCellId& aCellId, TDes& aNameInto) = 0;
	virtual TBool NameCity(const class TBBCellId& aCellId, TDes& aNameInto) = 0;
	virtual TBool GetExistingCell(TInt aBaseId, const class TBBCellId& aCellId, TDes& aNameInto) = 0;
	virtual TBool GetExistingCity(const class TBBCellId& aCellId, TDes& aNameInto) = 0;
};

class CAutoTagArray : public CBase, public MDesCArray {
public:
	IMPORT_C static CAutoTagArray*	NewL(MAskForNames* aAskForNames=0,
		class CHintBox* aHints=0);

	virtual TInt GetIncludedTagsBitField() const = 0;
	virtual void ToggleField(TInt aIndex) = 0;
	virtual void ClearField(TInt aIndex) = 0;

	virtual TInt GetSharing() const = 0;
	virtual void SetPost(class CCMPost* aPost) = 0;
	virtual TInt GetIndexBit(TInt aIndex) const = 0;
	virtual TBool IsKnown(TInt aIndex) const = 0;
};

class CAutoTagListBox : public CCoeControl {
public:
	IMPORT_C static CAutoTagListBox* NewL(CAutoTagArray* aArray, 
		const CCoeControl* aParent, class CAknIconArray *aIconList,
		class CHintBox* aHintBox);

	virtual TInt RowHeight() = 0;
	virtual TInt Width() = 0;
	virtual TInt BorderWidth() = 0;
	IMPORT_C static class CAknIconArray * CreateIconList();
	virtual void SetCurrentItemIndexAndDraw(TInt aItemIndex) const = 0;
	virtual void SetTopItemIndex(TInt aItemIndex) const = 0;
	virtual TInt CurrentItemIndex() const = 0;
	virtual TInt BottomItemIndex() const = 0;
	virtual TInt TopItemIndex() const = 0;
	virtual void SetCurrentItemIndex(TInt aItemIndex) const = 0;
};

#endif
