#ifndef MEDIALISTBOX_H_INCLUDED
#define MEDIALISTBOX_H_INCLUDED

#include "cm_storage.h"
#include "cm_network.h"
#include <eikfrlb.h>

class CContextMediaArray : public CBase, public MDesCArray, public MPostNotify {
public:
	enum TAdditionalItem {ENone, EAddReply, EUseVCode};
public:
	IMPORT_C static CContextMediaArray* NewL(CCMNetwork & aNetwork,
					CPostStorage &aStorage, 
					TInt64 aNode, 
					CPostStorage::TSortBy aSort, 
					CPostStorage::TOrder aOrder,
					MPostNotify& aObserver, TAdditionalItem aItem,
					TBool aStandAlone);
public:
	virtual CCMPost*  GetPostAt(TInt aIndex) = 0;
};



class CContextMediaBox : public CEikFormattedCellListBox
{
public:
	IMPORT_C CContextMediaBox(CContextMediaArray * aPostArray, TBool aStandAlone=EFalse);
	virtual void SizeChanged();
private:
	void CreateItemDrawerL(void);
public:
	virtual ~CContextMediaBox();
private:
	void AddSubCell(TMargins marg, TSize size, const CFont* aFont,
			TPoint pos, TInt baselinepos, 
			CGraphicsContext::TTextAlign aAlign=CGraphicsContext::ELeft, 
			TBool aGraphic=EFalse);

	CFormattedCellListBoxData* itemd;
	CContextMediaArray * iPostArray;
	CFont * iLatinPlainItalic12;
	TBool	iStandAlone;
	TInt	iScale, iCells;

	friend class CContextMediaAppListboxContainer;
};


#endif