#ifndef __VIDEO_ENGINE_H__
#define __VIDEO_ENGINE_H__

#include <e32base.h>

enum TPlayerErrCode
	{
	KErrReOpen = 101,
	KErrAutoDisconnect,
	KErrAudioLost
	};


class CVideoEngine : public CBase
{
public:
	// returns 0 on S60v1
	IMPORT_C static CVideoEngine* NewL();

	virtual void DoStopL() = 0;
	virtual void DoPlayL() = 0;
	virtual void SetNewFileL(const TDesC& aFileName) = 0;
	virtual void DoPauseL() = 0;
	virtual TInt GetEngineState() = 0;
	enum TEngineState {EPNotInitialised, EPInitialising, EPStopped, EPPlaying, EPPaused};

	virtual TInt IncreaseVolume() = 0;
	virtual TInt DecreaseVolume() = 0;

        virtual void InitControllerL( class MPlayerUIControllerListener* aCallback,
                              class RWsSession& aWs,
                              class CWsScreenDevice& aScreenDevice,
                              class RWindowBase& aWindow,
                              class TRect& aScreenRect,
                              class TRect& aClipRect,
			      TInt volume) = 0;  
	virtual void CloseController() = 0;
};

#endif // __VIDEO_ENGINE_H__