#ifndef CONTEXT_SOCKETSLISTENER_H_INCLUDED
#define CONTEXT_SOCKETSLISTENER_H_INCLUDED 1

#include <e32std.h>
#include "checkedactive.h"
#include <es_sock.h>

class MSocketAcceptor {
public:
	virtual RSocket& GetSocket(RSocketServ& aServer) = 0;
	virtual void AcceptFinished(TInt aError) = 0;
	virtual ~MSocketAcceptor() { }
};

class MSocketAcceptorFactory {
public:
	virtual MSocketAcceptor* CreateAcceptorL() = 0;
};

class CSocketListener: public CCheckedActive {
public:
	IMPORT_C static CSocketListener* NewL(MSocketAcceptorFactory& aAcceptorFactory,
		TUint aListenPort);
protected:
	CSocketListener();
};

#endif
