/*
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


//CContextNotifySession.h
#ifndef __CCONTEXTNOTIFYSESSION__
#define __CCONTEXTNOTIFYSESSION__

#include <e32base.h>
#include "ContextNotify.h"
#include "list.h"
#include "compat_server.h"

#ifndef EKA2
class CContextNotifySession : public CSession
#else
class CContextNotifySession : public SESSION_CLASS
#endif
{

public: 
#ifndef EKA2
	static CContextNotifySession* NewL(RThread& aClient, CContextNotify& aServer);
	static CContextNotifySession* NewLC(RThread& aClient, CContextNotify& aServer);
#else
	static CContextNotifySession* NewL(CContextNotify& aServer);
	static CContextNotifySession* NewLC(CContextNotify& aServer);
#endif
	~CContextNotifySession();
	
	void ServiceL(const MESSAGE_CLASS & aMessage);

private:
#ifndef EKA2
	CContextNotifySession(RThread& aClient, CContextNotify& aServer);
#else
	CContextNotifySession(CContextNotify& aServer);
#endif
	void ConstructL() ;
	void PanicClient(TInt aPanic) const;

	void TerminateContextNotify(const MESSAGE_CLASS & aMessage);

	void CompleteMessage(TInt Code);

	void AddIcon();
	void RemoveIcon();
	void ChangeIcon();
public: 
	void NotifyEvent(CContextNotify::TEvent aEvent);
	void ReportError(TContextNotifyRqstComplete aErrorType, TDesC & aErrorCode, TDesC & aErrorValue);
private: 
	
	MESSAGE_CLASS            iMessage; TInt iMessageThreadId;
	void SetMessage(const MESSAGE_CLASS & aMsg);
	CContextNotify&     iServer;
	CList<TInt>		*iIds;
};

#endif
