#ifndef CONTEXT_CSD_EVENT_H_INCLUDED
#define CONTEXT_CSD_EVENT_H_INCLUDED 1

#include "bbdata.h"
#include "concretedata.h"
#include "context_uids.h"
#include "bbtypes.h"
#include "bbtuple.h"

const TTypeName KEventType = { { CONTEXT_UID_SENSORDATAFACTORY }, 10, 1, 0 };

const TTupleName KAppEventTuple = { { CONTEXT_UID_CONTEXTSENSORS }, 19 };
const TTupleName KCellAnnotationTuple = { { CONTEXT_UID_CONTEXTSENSORS }, 20 };
const TTupleName KWebSearchTuple = { { CONTEXT_UID_CONTEXTSENSORS }, 21 };

const TTupleName KStatusTuple = { { CONTEXT_UID_CONTEXTSENSORS }, 36 };

const TTupleName KAnySensorEvent = { { CONTEXT_UID_CONTEXTSENSORS }, 0 };

_LIT(KEvent, "event");

class CBBSensorEvent : public CBase, public TBBCompoundData {
public:
	enum TPriority {
		INFO,
		DEBUG,
		VALUE,
		UNCHANGED_VALUE,
		ERR
	};

	TBBTime			iStamp;
	TBBInt			iPriority;
	TBBShortString		iName;
	CBBGeneralHolder	iData;

	IMPORT_C const TTupleName& TupleName() const;
        IMPORT_C const TDesC&    Name() const;

        IMPORT_C virtual const TTypeName& Type() const;
	IMPORT_C virtual TBool Equals(const MBBData* aRhs) const;

	IMPORT_C static const TTypeName& StaticType();
	IMPORT_C const MBBData* Part(TUint aPartNo) const;

	IMPORT_C CBBSensorEvent(const TDesC& aName, const TTupleName& aTupleName, 
		MBBDataFactory* aFactory=0, TTime aTime=TTime(0), MBBData* iData=0, TPriority aPriority=VALUE);

	IMPORT_C bool operator==(const CBBSensorEvent& aRhs) const;
	IMPORT_C virtual const TDesC& StringSep(TUint aBeforePart) const;

	IMPORT_C CBBSensorEvent& operator=(const CBBSensorEvent& aSensorEvent);
	IMPORT_C MBBData* CloneL(const TDesC& Name) const;
private:
	IMPORT_C MBBData* GetPart(const TDesC& aName, const TTypeName& aType, TUint& aPartNoInto);
	MBBDataFactory*	iFactory;
	const TTupleName& iTupleName;
};

#endif
