/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/

#ifndef SETTINGSVIEW_H
#define SETTINGSVIEW_H

#include <aknview.h>
#include <aknsettingitemlist.h>
#include "app_context.h"
#include "cl_settings.h"
#include "settings.h"
#include "app_local_settings.h"

#ifndef NULL
#define NULL 0
#endif

class CSettingsView : public CAknView, public MContextBase
{
public: // Constructors and destructor
	IMPORT_C static CSettingsView* NewL(TUid aViewId, MApp_context& Context, 
		const TInt * EnabledSettings, TBool aOnlyContextLogPublishing=EFalse);
        IMPORT_C ~CSettingsView();
	IMPORT_C void SetPreviousLocalViewId(TUid aViewId);

public: // Functions from base classes
        TUid Id() const;
        void HandleCommandL(TInt aCommand);
        void HandleClientRectChange();

private:
	CSettingsView(TUid aViewId, MApp_context& Context, const TInt * EnabledSettings,
		TBool aOnlyContextLogPublishing);
        void ConstructL();
        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId, const TDesC8& aCustomMessage);
        void DoDeactivate();

private: 
        class CCLSettingList* iListBox;
	TUid iViewId;
	TVwsViewId iPreviousViewId;
	TUid	   iPreviousLocalViewId;
	TInt		iResource;
	const TInt  * iEnabledSettings;
	TBool	   iOnlyContextLogPublishing;
	TBool		iIsActivated;
};

#endif

// End of File
