#ifndef CONTEXT_HINTBOX_H_INCLUDED
#define CONTEXT_HINTBOX_H_INCLUDED 1

#include <e32base.h>
#include <coecntrl.h>

class CTextBox : public CCoeControl {
	/* This class will draw a floating window with some
	   text, nicely word-wrapped. You can anchor to window
	   to any of the for corners. It'll calculate the minimum
	   size needed based on the maximum width given, and use
	   that */
public:
	enum TPosition {
		ETopLeft,
		ETopRight,
		EBottomLeft,
		EBottomRight
	};
	IMPORT_C static CTextBox* NewL(TRgb aBackgroundColor, TRgb aForegroundColor,
			TRgb aBorderColor, TInt aBorder, TInt aMargin);
	/* doesn't take ownership of the text, you need to make
	   sure it's lifetime is long enough*/
	virtual void SetText(TInt aMaxWidth, HBufC* aText, TPosition aPosFrom,
			TPoint aPos) = 0;
	virtual void Reset() = 0;
};

class CHintBox : public CBase {
public:
	IMPORT_C static CHintBox* NewL(const struct TTupleName& aTupleName,
		TInt aScale);
	virtual void AddHintL(TInt aHintId, TInt aPriority,
		CTextBox::TPosition aPosFrom, const class TPoint& aPos,
		TInt aMaxWidth,
		TInt aHintResourceId) = 0;
	virtual void ShowHintIfNotDismissed(TInt aHintId) = 0;
	virtual void DontShow() = 0;
	virtual void DismissHint(TInt aHintId) = 0;
};

#endif
