#include "cu_cellnaming.h"
#include "app_context_impl.h"
#include "cbbsession.h"
#include <contextui.rsg>
#include <eikenv.h>
#include <coeaui.h>
#include "csd_event.h"
#include "emptytext.h"
#include "csd_cell.h"
#include "break.h"
#include <bautils.h>

void name_cellL(const TTupleName& aNameTuple, 
				const TDesC& aNameName)
{
	if ( ((CCoeAppUi*)CEikonEnv::Static()->AppUi())->IsDisplayingMenuOrDialog()) return;

	const TInt NAME_LENGTH=255;
	auto_ptr<HBufC> textData(HBufC::NewL(NAME_LENGTH));

	MBBData* name_event_m=0;
	GetContext()->BBSession()->GetL(aNameTuple, KNullDesC, name_event_m, ETrue);
	bb_auto_ptr<MBBData> eventp(name_event_m);
	const CBBSensorEvent* name_event=bb_cast<CBBSensorEvent>(name_event_m);
	const TBBFixedLengthStringBase* existing_name=0;
	if (name_event) {
		existing_name=bb_cast<TBBShortString>(name_event->iData());
		if (!existing_name) existing_name=bb_cast<TBBLongString>(name_event->iData());
	}

	if (existing_name) textData->Des()=existing_name->Value();
	
	TPtr16 p=textData->Des();

	auto_ptr<HBufC> f(0);
	if (aNameTuple==KCellNameTuple) {
		f.reset(CEikonEnv::Static()->AllocReadResourceL(R_CL_NAME_OLD_CELL_CAPTION));
	} else {
		// city
		f.reset(CEikonEnv::Static()->AllocReadResourceL(R_CL_NAME_OLD_CITY_CAPTION));
	}
	auto_ptr<HBufC> pr(HBufC::NewL(f->Des().Length()+4));
	pr->Des()=*f;

	CAknTextQueryDialog* dlg = new(ELeave) CEmptyAllowingTextQuery(p);
	CleanupStack::PushL(dlg);
	dlg->SetMaxLength(NAME_LENGTH);
	dlg->SetPromptL(*pr);
	CleanupStack::Pop();
	if (dlg->ExecuteLD(R_CONTEXT_LOG_NAME_INPUT) && textData->Length())
	{
		if (existing_name && existing_name->Value().Compare(*textData)==0) return;

		TTime exp=GetTime();
		exp+=TTimeIntervalMinutes(10);
		bb_auto_ptr<CBBSensorEvent> e(new (ELeave) CBBSensorEvent(aNameName,
			aNameTuple, GetContext()->BBDataFactory(), GetTime()));
		e->iData.SetOwnsValue(EFalse);
		TBBLongString name(*textData, aNameName);
		e->iData.SetValue(&name);
		GetContext()->BBSession()->PutL(aNameTuple, KNullDesC, e.get(),
			exp);
	}
}

TInt LoadResourceFileL() {
#ifndef __WINS__
		TFileName resfile=_L("c:\\System\\data\\contextui.rsc");
		if (! BaflUtils::FileExists(CEikonEnv::Static()->FsSession(), resfile) ) {
			resfile.Replace(0, 1, _L("e"));
		}
#else
		TFileName resfile=_L("z:\\System\\data\\contextui.rsc");
		BaflUtils::NearestLanguageFile(CEikonEnv::Static()->FsSession(), resfile); //for localization
#endif
		return CEikonEnv::Static()->AddResourceFileL(resfile);
}
EXPORT_C void AskUserForCurrentCellNameL()
{
	TInt res=LoadResourceFileL();
	CC_TRAPD(err, name_cellL(KCellNameTuple, KCellName));
	if (res) CEikonEnv::Static()->DeleteResourceFile(res);
	User::LeaveIfError(err);
}

EXPORT_C void AskUserForCurrentCityNameL()
{
	TInt res=LoadResourceFileL();
	CC_TRAPD(err, name_cellL(KCityNameTuple, KCity));
	if (res) CEikonEnv::Static()->DeleteResourceFile(res);
	User::LeaveIfError(err);
}
