/*
* ============================================================================
*  Name     : CTaskListAppUi from TaskListAppUi.cpp
*  Part of  : TaskList
*  Created  : 13.4.2004 by 
*  Implementation notes:
*     Initial content was generated by Series 60 AppWizard.
*  Version  :
*  Copyright: 
* ============================================================================
*/

/*
 * Concepts:
 * !Getting thread and process information!
 * !Killing threads!
 */


// INCLUDE FILES
#include "TaskListAppUi.h"
#include "TaskListContainer.h" 
#include <TaskList.rsg>
#include "tasklist.hrh"

#include <avkon.hrh>
#include <aknmessagequerydialog.h>

#ifdef __S80__
#include <ckninfo.h>
#endif

// ================= MEMBER FUNCTIONS =======================
//
// ----------------------------------------------------------
// CTaskListAppUi::ConstructL()
// ?implementation_description
// ----------------------------------------------------------
//
void CTaskListAppUi::ConstructL()
{
	BaseConstructL();
	
	iThreadNames=new (ELeave) CDesC16ArrayFlat(4);
	iThreadIds=new (ELeave) CArrayFixFlat<TThreadId>(4);
	
	GetThreads();
	
	iAppContainer = new (ELeave) CTaskListContainer;
#ifndef __S80__
	iAppContainer->SetMopParent(this);
#endif
	iAppContainer->ConstructL( ClientRect(), iThreadNames, this );
	AddToStackL( iAppContainer );
}

// ----------------------------------------------------
// CTaskListAppUi::~CTaskListAppUi()
// Destructor
// Frees reserved resources
// ----------------------------------------------------
//
CTaskListAppUi::~CTaskListAppUi()
{
	if (iAppContainer)
        {
		RemoveFromStack( iAppContainer );
		delete iAppContainer;
        }
	delete iThreadNames;
	delete iThreadIds;
}

void CTaskListAppUi::GetThreads()
{
	TFindThread f(_L("*"));
	TFullName t;
	RThread r;
	iThreadNames->Reset();
	iThreadIds->Reset();
	while (f.Next(t)==KErrNone) {
		r.Open(t);
		CleanupClosePushL(r);
		iThreadNames->AppendL(t);
		iThreadIds->AppendL(r.Id());
		CleanupStack::PopAndDestroy();
	}
}

// ------------------------------------------------------------------------------
// CTaskListAppUi::::DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane)
//  This function is called by the EIKON framework just before it displays
//  a menu pane. Its default implementation is empty, and by overriding it,
//  the application can set the state of menu items dynamically according
//  to the state of application data.
// ------------------------------------------------------------------------------
//
void CTaskListAppUi::DynInitMenuPaneL(
				      TInt /*aResourceId*/,CEikMenuPane* /*aMenuPane*/)
{
}

// ----------------------------------------------------
// CTaskListAppUi::HandleKeyEventL(
//     const TKeyEvent aKeyEvent,TEventCode /*aType*/)
// ?implementation_description
// ----------------------------------------------------
//
TKeyResponse CTaskListAppUi::HandleKeyEventL(
					     const TKeyEvent& /*aKeyEvent*/,TEventCode /*aType*/)
{
	return EKeyWasNotConsumed;
}

// ----------------------------------------------------
// CTaskListAppUi::HandleCommandL(TInt aCommand)
// ?implementation_description
// ----------------------------------------------------
//
void CTaskListAppUi::KillCurrent()
{
	TInt idx=iAppContainer ->GetCurrentIdx();
	TThreadId id=iThreadIds->At(idx);
	RThread t;
	t.Open(id);
	t.Kill(-1000);
	t.Close();
	GetThreads();
	iAppContainer->ContentsChanged();
}

void CTaskListAppUi::HandleCommandL(TInt aCommand)
{
	switch ( aCommand )
        {
        case EAknSoftkeyBack:
        case EEikCmdExit:
		{
			Exit();
			break;
		}
        case ETaskListCmdAppKill:
		{
			KillCurrent();
			break;
		}
		// TODO: Add Your command handling code here
		
	case ETaskListCmdAppRefresh:
		{
			GetThreads();
			iAppContainer->ContentsChanged();
		}
        default:
		break;      
        }
}

void FormatHex(const TDesC8& from, TDes& into)
{
	TInt len=from.Length();
	TInt space=into.MaxLength()/2;

	if (len > space) len=space;
	TBuf<4> hex, b;
	for (int i=0; i<len; i++) {		
		hex.Num( from[i], EHex );
		if (hex.Length()==1) b=_L("0");
		else b.Zero();
		b.Append(hex);
		into.Append(b);
	}

}

void CTaskListAppUi::HandleListBoxEventL(CEikListBox* aListBox,TListBoxEvent aEventType)
{
	if (aEventType != EEventItemClicked && aEventType!=EEventEnterKeyPressed) return;
	TBuf<400> msg;
	
	TInt idx=iAppContainer ->GetCurrentIdx();
	TThreadId id=iThreadIds->At(idx);
	TUint i=id;
	RProcess p;
	RThread t;
	t.Open(id);

	TInt aHeapSize; TInt aStackSize;
	t.GetRamSizes(aHeapSize, aStackSize);
	TBuf8<256> context;
	t.Context(context);
	TBuf<16> context_beg;
	FormatHex(context, context_beg);


	TInt etype, ereason;
	TExitCategoryName ecat;
	etype=t.ExitType();
	ereason=t.ExitReason();
	ecat=t.ExitCategory();

	t.Process(p);
	t.Close();
	TUint pi=p.Id();

	HBufC* cmd=HBufC::NewLC(p.CommandLineLength());
	p.Open(p.Id());
	TPtr cmdp=cmd->Des();
	p.CommandLine(cmdp);

	//TInt aCodeSize=0; TInt aConstDataSize=0; TInt anInitialisedDataSize=0; TInt anUninitialisedDataSize=0;
	//p.GetRamSizes(aCodeSize, aConstDataSize, anInitialisedDataSize, anUninitialisedDataSize);

	TFileName file=p.FileName();
	p.Close();

	//msg.Format(_L("T Id: %x\nP Id: %x\nEType %d EReason %d\nECat %S\nCmd: %S\n"), i, pi, etype, ereason, ecat,
	//	(*cmd));
	msg.Format(_L("T Id: %x\nContext: %S\nP Id: %x\nFile: %S\nCmd: %S\nHeap: %d\nStack: %d\n"), i, &context_beg, pi, &file,
		&(*cmd), aHeapSize/1024, aStackSize/1024);
#ifndef __S80__
	CAknMessageQueryDialog* note=CAknMessageQueryDialog::NewL(msg);
	note->ExecuteLD(R_LOGVIEW_EVENT_DIALOG);
#else
	CCknInfoDialog::RunDlgDefaultIconLD(msg, 0);
#endif
	CleanupStack::PopAndDestroy(); //cmd
}

// End of File  
