/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/

#ifndef CONTEXT_LOGAPPUI_H
#define CONTEXT_LOGAPPUI_H

#define NULL 0

// INCLUDES
#include <eikapp.h>
#include <eikdoc.h>
#include <e32std.h>
#include <coeccntx.h>

#include "timeout.h"

#include <sendas.h>

#include "csd_cell.h"
#include "bb_logger.h"

class CSmsSocket;

class CNotifyState;

#include "appuibase.h"
// CONSTANTS
//const ?type ?constant_var = ?constant;


// CLASS DECLARATION

/**
* Application UI class.
* Provides support for the following features:
* - EIKON control architecture
* 
*/
class CContextLocaAppUi : public CContextLogAppUiBase,
	public MSendAsObserver, 
	public MSettingListener
{
public: // // Constructors and destructor
	
	CContextLocaAppUi(MApp_context& Context) : CContextLogAppUiBase(Context) { }
        /**
        * EPOC default constructor.
        */      
        void ConstructL();
	
        /**
        * Destructor.
        */      
        ~CContextLocaAppUi();
        
public: // New functions
	
public: // Functions from base classes
	
private:
        // From MEikMenuObserver
        void DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane);

private:
	
	// MSettingListener
	virtual void SettingChanged(TInt Setting);

        /**
        * From CEikAppUi, takes care of command handling.
        * @param aCommand command to be handled
        */
        void HandleCommandL(TInt aCommand);
private:

public:
	void DialogTest();	
private:
	// MSendAsObserver
	virtual TBool CapabilityOK(TUid /*aCapabilty*/, TInt /*aResponse*/) { return ETrue; }

private: //Data

	class CSendUITransfer* transferer;

	class CAknGlobalNote* globalNote;
	
	bool case_closed;
	bool ringing;

	class CBBLogger*	bbl;

	class CConnectionOpener* iConnectionOpener;

	RSocketServ	iServ;
#ifdef __S60V2__
	RConnection	iConnection;
#endif

	class CNotifyState		*iContextRunning, *iLoggingRunning;
	class CLocaSender	*iLocaSender;
	class CSmsStatusReplier	*iSmsStatus;

	class CBBLocalRunner	*iBBLocal;
};

#endif

// End of File
