#!/usr/bin/perl

$EPOC=$ENV{'EPOCROOT'};
if ($EPOC=~/^\s*$/) {
	die "EPOCROOT must be set"
}
my $SDK=$ENV{'EPOCROOT'};
$SDK=~s/.*\\([^\\]*)\\$/$1/;

@defs=();

if ($EPOC =~ /6\.1\\series60/i) {
	push(@defs, "__S60V1__");
} elsif ($EPOC =~ /7.0s\\series60_v20/i) {
	push(@defs, "__S60V2__");
	push(@defs, "__S60V20__");
} elsif ($EPOC =~ /7.0s\\series60_v21/i) {
	push(@defs, "__S60V2__");
	push(@defs, "__S60V21__");
} elsif ($EPOC =~ /8.0a.*FP2/i) {
	push(@defs, "__S60V2__");
	push(@defs, "__S60V2FP2__");
} elsif ($EPOC =~ /8\.1a.*FP3/i) {
	push(@defs, "__S60V2__");
	push(@defs, "__S60V2FP3__");
}

open(MMP, "<$EPOC\\epoc32\\include\\sdk_version.mmp");
while(<MMP>) { $MMP.=$_; }
close(MMP);

open(H, "<$EPOC\\epoc32\\include\\sdk_version.h");
while(<H>) { $H.=$_; }
close(H);

foreach $d (@defs) {
	$wanted_mmp .= "MACRO $d\n";
	$wanted_mmp .= "#define $d\n";
	$wanted_h .= "#define $d\n";
}
$wanted_mmp .= "#define __SDK__ $SDK\n";
$wanted_mmp .= "#ifdef WINS\n";
$wanted_mmp .= "#define DEFFILENAME(x) DEFFILE .\\ ## Series60_v21 ## \\ ## x ## -wins.DEF\n";
$wanted_mmp .= "#else\n";
$wanted_mmp .= "#define DEFFILENAME(x) DEFFILE .\\ ## Series60_v21 ## \\ ## x ## -thumb.DEF\n";
$wanted_mmp .= "#endif\n";

unless ($MMP eq $wanted_mmp) {
	open(MMP, ">$EPOC\\epoc32\\include\\sdk_version.mmp");
	print MMP $wanted_mmp;
	close(MMP);
}

unless ($H eq $wanted_h) {
	open(H, ">$EPOC\\epoc32\\include\\sdk_version.h");
	print H $wanted_h;
	close(H);
}
